org.codehaus.groovy.runtime.metaclass

## Class MemoryAwareConcurrentReadMap

- java.lang.Object
- - org.codehaus.groovy.runtime.metaclass.MemoryAwareConcurrentReadMap

-     public class MemoryAwareConcurrentReadMap
      extends Object

  This Map is a stripped down version of ConcurrentReaderHashMap with small modifications here and there. It is no full Map, it does have put/get/remove, but no iterators. This map is intended to hold values and keys as SoftReference. If one of value or key are removed, so will be complete entry. This map will not use the equals method to compare keys, think of it as a IdentityHashMap with features of concurrency and memory aware caching. As ConcurrentReaderHashMap also does this implementation prefer read operations and tries not to lock if possible. SoftReferenced values are only removed from the map if the map goes into a synchronization block on this. This may affect reads, but only in rare cases.
  Author:
    Adapted from ConcurrentHashMap (Doug Lea), adapted by the Groovy community

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static class` | `MemoryAwareConcurrentReadMap.BarrierLock` A Serializable class for barrier lock

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected MemoryAwareConcurrentReadMap.BarrierLock` | `barrierLock` Lock used only for its memory effects.
    `protected int` | `count` The total number of mappings in the hash table.
    `static int` | `DEFAULT_INITIAL_CAPACITY` The default initial number of table slots for this table (32).
    `static float` | `DEFAULT_LOAD_FACTOR` The default load factor for this table (1.0).
    `protected Object` | `lastWrite` field written to only to guarantee lock ordering.
    `protected float` | `loadFactor` The load factor for the hash table.
    `protected org.codehaus.groovy.runtime.metaclass.MemoryAwareConcurrentReadMap.Entry[]` | `table` The hash table data.
    `protected int` | `threshold` The table is rehashed when its size exceeds this threshold.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MemoryAwareConcurrentReadMap()` Constructs a new, empty map with a default initial capacity and load factor.
    `MemoryAwareConcurrentReadMap(int initialCapacity)` Constructs a new, empty map with the specified initial capacity and default load factor.
    `MemoryAwareConcurrentReadMap(int initialCapacity, float loadFactor)` Constructs a new, empty map with the specified initial capacity and the specified load factor.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clear()` Removes all mappings from this map.
    `protected boolean` | `eq(Object x, Object y)` Check for referential equality, null allowed
    `Object` | `get(Object key)` Returns the value to which the specified key is mapped in this table.
    `protected org.codehaus.groovy.runtime.metaclass.MemoryAwareConcurrentReadMap.Entry[]` | `getTableForReading()` Get ref to table; the reference and the cells it accesses will be at least as fresh as from last use of barrierLock
    `boolean` | `isEmpty()` Returns `true` if this map contains no key-value mappings.
    `Object` | `put(Object key, Object value)` Maps the specified `key` to the specified `value` in this table.
    `protected void` | `recordModification(Object x)` Force a memory synchronization that will cause all readers to see table.
    `protected void` | `rehash()` Rehashes the contents of this map into a new table with a larger capacity.
    `Object` | `remove(Object key)` Removes the key (and its corresponding value) from this table.
    `int` | `size()` Returns the number of key-value mappings in this map.
    `protected Object` | `sput(Object key, Object value, int hash)` Continuation of put(), called only when synch lock is held and interference has been detected.
    `protected Object` | `sremove(Object key, int hash)` Continuation of remove(), called only when synch lock is held and interference has been detected.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### barrierLock

          protected final MemoryAwareConcurrentReadMap.BarrierLock barrierLock

      Lock used only for its memory effects.

    - #### lastWrite

          protected transient Object lastWrite

      field written to only to guarantee lock ordering.

    - #### DEFAULT_INITIAL_CAPACITY

          public static final int DEFAULT_INITIAL_CAPACITY

      The default initial number of table slots for this table (32). Used when not otherwise specified in constructor.
      See Also:
        Constant Field Values

    - #### DEFAULT_LOAD_FACTOR

          public static final float DEFAULT_LOAD_FACTOR

      The default load factor for this table (1.0). Used when not otherwise specified in constructor.
      See Also:
        Constant Field Values

    - #### table

          protected transient org.codehaus.groovy.runtime.metaclass.MemoryAwareConcurrentReadMap.Entry[] table

      The hash table data.

    - #### count

          protected transient int count

      The total number of mappings in the hash table.

    - #### threshold

          protected int threshold

      The table is rehashed when its size exceeds this threshold. (The value of this field is always (int)(capacity * loadFactor).)

    - #### loadFactor

          protected float loadFactor

      The load factor for the hash table.

  - ### Constructor Detail

    - #### MemoryAwareConcurrentReadMap

          public MemoryAwareConcurrentReadMap(int initialCapacity,
                                      float loadFactor)

      Constructs a new, empty map with the specified initial capacity and the specified load factor.
      Parameters:
        `initialCapacity` - the initial capacity The actual initial capacity is rounded to the nearest power of two.
        `loadFactor` - the load factor of the ConcurrentReaderHashMap
      Throws:
        `IllegalArgumentException` - if the initial maximum number of elements is less than zero, or if the load factor is non-positive.

    - #### MemoryAwareConcurrentReadMap

          public MemoryAwareConcurrentReadMap(int initialCapacity)

      Constructs a new, empty map with the specified initial capacity and default load factor.
      Parameters:
        `initialCapacity` - the initial capacity of the ConcurrentReaderHashMap.
      Throws:
        `IllegalArgumentException` - if the initial maximum number of elements is less than zero.

    - #### MemoryAwareConcurrentReadMap

          public MemoryAwareConcurrentReadMap()

      Constructs a new, empty map with a default initial capacity and load factor.

  - ### Method Detail

    - #### recordModification

          protected final void recordModification(Object x)

      Force a memory synchronization that will cause all readers to see table. Call only when already holding main synch lock.

    - #### getTableForReading

          protected final org.codehaus.groovy.runtime.metaclass.MemoryAwareConcurrentReadMap.Entry[] getTableForReading()

      Get ref to table; the reference and the cells it accesses will be at least as fresh as from last use of barrierLock

    - #### eq

          protected boolean eq(Object x,
                   Object y)

      Check for referential equality, null allowed

    - #### size

          public int size()

      Returns the number of key-value mappings in this map.
      Returns:
        the number of key-value mappings in this map.

    - #### isEmpty

          public boolean isEmpty()

      Returns `true` if this map contains no key-value mappings.
      Returns:
        `true` if this map contains no key-value mappings.

    - #### get

          public Object get(Object key)

      Returns the value to which the specified key is mapped in this table.
      Parameters:
        `key` - a key in the table.
      Returns:
        the value to which the key is mapped in this table; `null` if the key is not mapped to any value in this table.
      Throws:
        `NullPointerException` - if the key is `null`.
      See Also:
        `put(Object, Object)`

    - #### put

          public Object put(Object key,
                   Object value)

      Maps the specified `key` to the specified `value` in this table. Neither the key nor the value can be `null`.

      The value can be retrieved by calling the `get` method with a key that is equal to the original key.

      Parameters:
        `key` - the table key.
        `value` - the value.
      Returns:
        the previous value of the specified key in this table, or `null` if it did not have one.
      Throws:
        `NullPointerException` - if the key or value is `null`.
      See Also:
        `get(Object)`

    - #### sput

          protected Object sput(Object key,
                    Object value,
                    int hash)

      Continuation of put(), called only when synch lock is held and interference has been detected.

    - #### rehash

          protected void rehash()

      Rehashes the contents of this map into a new table with a larger capacity. This method is called automatically when the number of keys in this map exceeds its capacity and load factor.

    - #### remove

          public Object remove(Object key)

      Removes the key (and its corresponding value) from this table. This method does nothing if the key is not in the table.
      Parameters:
        `key` - the key that needs to be removed.
      Returns:
        the value to which the key had been mapped in this table, or `null` if the key did not have a mapping.
      Throws:
        `NullPointerException` - if the key is `null`.

    - #### sremove

          protected Object sremove(Object key,
                       int hash)

      Continuation of remove(), called only when synch lock is held and interference has been detected.

    - #### clear

          public void clear()

      Removes all mappings from this map.